(height, percent, charge, low, lpm, m_color, b_color) {
	function draw_rRect_cw( left, top, right, bottom, r ) {
		ctx.moveTo( left + r, top );
		ctx.lineTo( right - r, top );
		ctx.arc( right - r, top + r, r, -pi/2, 0, false);
		ctx.lineTo( right,  bottom - r );
		ctx.arc( right - r, bottom - r, r, 0, pi/2, false);
		ctx.lineTo( left + r, bottom);
		ctx.arc( left + r, bottom - r, r, pi/2, pi, false);
		ctx.lineTo( left, top + r);
		ctx.arc( left + r, top + r, r, pi, pi*3/2, false);
	}
	function draw_rRect_ccw( left, top, right, bottom, r ) {
		ctx.moveTo( right - r, top );
		ctx.lineTo( left + r, top );
		ctx.arc( left + r, top + r, r, pi*3/2, pi, true);
		ctx.lineTo( left,  bottom - r );
		ctx.arc( left + r, bottom - r, r, pi, pi/2, true);
		ctx.lineTo( right - r, bottom);
		ctx.arc( right - r, bottom - r, r, pi/2, 0, true);
		ctx.lineTo( right, top + r );
		ctx.arc( right - r, top + r, r, 0, -pi/2, true);
	}
	function draw_charging( ) {
		ctx.moveTo( r+m*11.5, p_Top+r );
		ctx.lineTo( r+m*9, p_Top+r+m*3.5 );
		ctx.lineTo( r+m*13, p_Top+r+m*3.5 );
		ctx.lineTo( r+m*5.5, p_Top+r+m*8 );
		ctx.lineTo( r+m*8, p_Top+r+m*4.5 );
		ctx.lineTo( r+m*4, p_Top+r+m*4.5 );
		ctx.lineTo( r+m*11.5, p_Top+r );
	}
	function draw_charged( ) {
		var x = [ 2, 2, 6, 8, 12, 12, 14, 14, 12, 12, 14, 14, 12, 12, 8, 6 ];
		var y = [ 3, 5, 5, 7, 7, 6, 6, 5, 5, 3, 3, 2, 2, 1, 1, 3 ];
		ctx.moveTo( r+m*x[0], p_Top+r+m*y[0] );
		for( var i=1; i<x.length; i++ ){
			ctx.lineTo( r+m*x[i], p_Top+r+m*y[i] );
		}
	}
	
	var canvas = document.createElement("canvas");
	var r = height / 20;
	canvas.height = height/2 + r*2;
	canvas.width = height/2 * 2.1;
	var ctx = canvas.getContext("2d");
	
	var m = height / 20;
	var p_Left = 0;
	var p_Right = height/2 * 1.9;
	var p_Top = 0 +r;
	var p_Bottom = height/2 +r;
	var pi = Math.PI;
	var s_color = [ 255-b_color[0], 255-b_color[1], 255-b_color[2] ];
	
	ctx.fillStyle = "rgb(" + b_color.slice(0, 3).join()+ ")";
	ctx.shadowColor = "rgb(" + s_color.join()+ ")";
	ctx.shadowBlur = r/2;
	ctx.shadowOffsetY = -r/2;
	ctx.beginPath();
	draw_rRect_cw( p_Right-r, p_Top + m*3, p_Right + m*2, p_Bottom - m*3, r );
	draw_rRect_cw( p_Left, p_Top, p_Right, p_Bottom, r );
	draw_rRect_ccw( p_Right, p_Top + m*3+r, p_Right + m*2-r, p_Bottom - m*3-r, 0 );
	if ( charge == true && percent == 100 ) {
		draw_charged();
		ctx.fill();
		return canvas.toDataURL("image/png");
	}
	else {
		draw_rRect_ccw( p_Left+r, p_Top+r, p_Right-r, p_Bottom-r, 0 );
		ctx.fill();
	}
	var rectWidth = ( p_Right - p_Left - r*4 ) * percent / 100;
	if ( percent <= 20 ) {
		rectWidth = rectWidth * 5;
		ctx.fillStyle = "red";
	}
	ctx.beginPath();
	draw_rRect_cw( p_Left+r*2, p_Top+r*2, p_Left+r*2+rectWidth, p_Bottom-r*2, 0 );
	ctx.fill();
	
	if ( charge == true && percent < 100 ) {
		ctx.globalCompositeOperation = "destination-out"; 
		ctx.shadowBlur = 0;
		ctx.shadowOffsetY = 0;
		ctx.beginPath();
		draw_charging();
		ctx.fill();

		ctx.globalCompositeOperation = "source-over"; 
		ctx.strokeStyle = "rgb(" + b_color.slice(0, 3).join()+ ")";
		ctx.shadowBlur = 0;
		ctx.shadowOffsetY = 0;
		ctx.beginPath();
		draw_charging();
		ctx.stroke();

		ctx.globalCompositeOperation = "destination-over"; 
		ctx.shadowBlur = r/2;
		ctx.shadowOffsetY = -r/2;
		ctx.beginPath();	
		draw_charging();
		ctx.stroke();	
	}

	return canvas.toDataURL("image/png");
}
